/*
 * codegentest: test the codegenerator against a hand built AST
 * (copied from asttest!)
 */

#include <stdio.h>
#include <stdlib.h>

#include "bool.h"
#include "lexer.h"
#include "ast.h"
#include "parser.h"
#include "decs.h"


int main( int argc, char **argv )
{
	shapelist s = build_shapelist( "d", NULL, NULL );
	s = build_shapelist( "c", NULL, s );
	s = build_shapelist( "b", NULL, s );
	s = build_shapelist( "a", NULL, s );
	declnlist d = build_declnlist( "abcd", s, NULL );

	paramlist p = build_paramlist( "string", "gval", NULL );
	s = build_shapelist( "g", p, NULL );
	s = build_shapelist( "f", NULL, s );
	s = build_shapelist( "e", NULL, s );
	d = build_declnlist( "efg", s, d );

	p = build_paramlist( "intlist", "tail", NULL );
	p = build_paramlist( "int", "head", p );
	s = build_shapelist( "cons", p, NULL );
	s = build_shapelist( "nil", NULL, s );
	d = build_declnlist( "intlist", s, d );

	printf( "\nparse tree:\n\n" );
	print_declnlist( stdout, d );
	make_declns( d, "out" );

	exit(0);
	/*NOTREACHED*/
}
